# Creates a new custom object record that does not already exist.

This method will auto-generate an ID and create a new custom object. If an ID is specified for the custom object, an error will be thrown.

Endpoint: POST /customObjects/{tenantId}
Version: v1-2025-04-18
Security: knox-authorizer

## Security:

  - `knox-authorizer` (unknown)
    http bearer JWT

## Path parameters:

  - `tenantId` (string, required)
    The id of the tenant being accessed.

## Request body:

  - `application/json` (unknown)
    The custom object that you would like to be saved.

## Request fields (application/json):

  - `calculated_fields` (array)

  - `calculated_fields.calculation_expression` (string, required)
    The expression to use the generate the field value

  - `calculated_fields.conditional_expression` (string)

  - `calculated_fields.description` (string)
    A description of the calculated field rule to help explain its purpose

  - `calculated_fields.enable_conditional_evaluation` (boolean)
    If true, this calculation is only performed on certain fields

  - `calculated_fields.field` (string, required)
    The field being calculated

  - `custom_field_values` (array)

  - `custom_field_values.boolean_value` (boolean)
    The boolean value

  - `custom_field_values.custom_field_id` (string)
    The unique identifier of the custom field

  - `custom_field_values.file_url_value` (string)
    The pointer to a file value

  - `custom_field_values.list_value` (array)
    The list value

  - `custom_field_values.numeric_value` (number)
    The numeric value

  - `custom_field_values.string_value` (string)
    The string value of the custom field

  - `custom_field_values.table_value` (array)
    A list of objects (a table)

  - `default_page_layout_id` (string)
    The default page layout to use

  - `default_table_fields` (array)

  - `default_table_fields.label` (string, required)

  - `default_table_fields.name` (string, required)

  - `enable_querying` (boolean)
    Whether or not querying should be enabled for this table

  - `enable_sorting` (boolean)
    If true, the records in the custom object will be sorted before they are saved

  - `id` (string, required)
    The unique, string identifier of this custom object

  - `name` (string, required)
    The name of the custom object

  - `name_plural` (string, required)
    The name of the custom object

  - `notes` (string)

  - `querying_options` (object, required)

  - `querying_options.dynamodb_table_name` (string, required)
    The name of the DynamoDB table where these records should be stored

  - `querying_options.error_message` (string)
    If there is an error, the error message

  - `querying_options.global_secondary_indexes` (array)

  - `querying_options.global_secondary_indexes.field` (string)

  - `querying_options.global_secondary_indexes.index_name` (string, required)
    The name of the index

  - `querying_options.global_secondary_indexes.type` (string, required)
    Enum: "single field"

  - `querying_options.provisioning_status` (string)
    Enum: "completed", "creating table", "error", "not yet started", "pending streaming activation"

  - `sort_fields` (array, required)

  - `sort_fields.name` (string, required)

  - `sort_fields.sort_order` (string, required)
    Enum: "ascending", "descending"

  - `sys_bulk_load_at` (string)
    If this record was loaded via bulk, the timestamp when the record was processed

  - `sys_bulk_load_id` (string)
    If this record was loaded via bulk, the ID of the bulk load process

  - `sys_bulk_load_pk` (string)
    If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

  - `sys_bulk_load_record_no` (number)
    If this record was loaded via bulk, the record number in the source file

  - `sys_bulk_load_source_file` (string)
    If this record was loaded via bulk, the source file

  - `sys_calculated_field_error` (string)
    The error associated with the calculated field

  - `sys_calculated_field_errors` (array)

  - `sys_calculated_field_errors.error` (string)

  - `sys_calculated_field_errors.field` (string)

  - `sys_configuration_snapshot_id` (string)
    If a snapshot was restored/applies to this record, the ID of the snapshot

  - `sys_created_at` (string, required)
    The date/time that this record was created, expressed in ISO-8601 date format

  - `sys_created_by_id` (string, required)
    The ID of the user that created this record

  - `sys_deleted_by_id` (string)
    The ID of the user that deleted (or last tried to delete) this object

  - `sys_directive` (string)
    Means for passing directive information into an object processing logic

  - `sys_external_id` (string)
    The ID that a record has from an external system or data import

  - `sys_has_files_in_s3` (boolean)
    If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

  - `sys_last_bulk_data_operation_id` (string)
    If this record was last touched by a bulk data operation, the ID of that operation

  - `sys_last_bulk_data_operation_sys_version` (string)
    If this record was last touched by a bulk data operation, the sys_version at the time of that operation

  - `sys_last_modified_at` (string, required)
    The date/time that this record record was last modified, expressed in ISO-8601 date format

  - `sys_last_modified_by_id` (string, required)
    The ID of the user that last modified this record

  - `sys_last_security_context` (object)
    The security context of the last insert, modify, or delete performed on this item

  - `sys_locked` (boolean)
    If set, this record is locked and cannot be changed via the API

  - `sys_snapshot_base_version` (number)
    The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

  - `sys_version` (number)
    A number representing the version of this record in the database

## Response 200:

  - `200` (unknown)
    The custom object was saved successfully.

## Response 200 fields (application/json):

  - `calculated_fields` (array)

  - `calculated_fields.calculation_expression` (string, required)
    The expression to use the generate the field value

  - `calculated_fields.conditional_expression` (string)

  - `calculated_fields.description` (string)
    A description of the calculated field rule to help explain its purpose

  - `calculated_fields.enable_conditional_evaluation` (boolean)
    If true, this calculation is only performed on certain fields

  - `calculated_fields.field` (string, required)
    The field being calculated

  - `custom_field_values` (array)

  - `custom_field_values.boolean_value` (boolean)
    The boolean value

  - `custom_field_values.custom_field_id` (string)
    The unique identifier of the custom field

  - `custom_field_values.file_url_value` (string)
    The pointer to a file value

  - `custom_field_values.list_value` (array)
    The list value

  - `custom_field_values.numeric_value` (number)
    The numeric value

  - `custom_field_values.string_value` (string)
    The string value of the custom field

  - `custom_field_values.table_value` (array)
    A list of objects (a table)

  - `default_page_layout_id` (string)
    The default page layout to use

  - `default_table_fields` (array)

  - `default_table_fields.label` (string, required)

  - `default_table_fields.name` (string, required)

  - `enable_querying` (boolean)
    Whether or not querying should be enabled for this table

  - `enable_sorting` (boolean)
    If true, the records in the custom object will be sorted before they are saved

  - `id` (string, required)
    The unique, string identifier of this custom object

  - `name` (string, required)
    The name of the custom object

  - `name_plural` (string, required)
    The name of the custom object

  - `notes` (string)

  - `querying_options` (object, required)

  - `querying_options.dynamodb_table_name` (string, required)
    The name of the DynamoDB table where these records should be stored

  - `querying_options.error_message` (string)
    If there is an error, the error message

  - `querying_options.global_secondary_indexes` (array)

  - `querying_options.global_secondary_indexes.field` (string)

  - `querying_options.global_secondary_indexes.index_name` (string, required)
    The name of the index

  - `querying_options.global_secondary_indexes.type` (string, required)
    Enum: "single field"

  - `querying_options.provisioning_status` (string)
    Enum: "completed", "creating table", "error", "not yet started", "pending streaming activation"

  - `sort_fields` (array, required)

  - `sort_fields.name` (string, required)

  - `sort_fields.sort_order` (string, required)
    Enum: "ascending", "descending"

  - `sys_bulk_load_at` (string)
    If this record was loaded via bulk, the timestamp when the record was processed

  - `sys_bulk_load_id` (string)
    If this record was loaded via bulk, the ID of the bulk load process

  - `sys_bulk_load_pk` (string)
    If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

  - `sys_bulk_load_record_no` (number)
    If this record was loaded via bulk, the record number in the source file

  - `sys_bulk_load_source_file` (string)
    If this record was loaded via bulk, the source file

  - `sys_calculated_field_error` (string)
    The error associated with the calculated field

  - `sys_calculated_field_errors` (array)

  - `sys_calculated_field_errors.error` (string)

  - `sys_calculated_field_errors.field` (string)

  - `sys_configuration_snapshot_id` (string)
    If a snapshot was restored/applies to this record, the ID of the snapshot

  - `sys_created_at` (string, required)
    The date/time that this record was created, expressed in ISO-8601 date format

  - `sys_created_by_id` (string, required)
    The ID of the user that created this record

  - `sys_deleted_by_id` (string)
    The ID of the user that deleted (or last tried to delete) this object

  - `sys_directive` (string)
    Means for passing directive information into an object processing logic

  - `sys_external_id` (string)
    The ID that a record has from an external system or data import

  - `sys_has_files_in_s3` (boolean)
    If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

  - `sys_last_bulk_data_operation_id` (string)
    If this record was last touched by a bulk data operation, the ID of that operation

  - `sys_last_bulk_data_operation_sys_version` (string)
    If this record was last touched by a bulk data operation, the sys_version at the time of that operation

  - `sys_last_modified_at` (string, required)
    The date/time that this record record was last modified, expressed in ISO-8601 date format

  - `sys_last_modified_by_id` (string, required)
    The ID of the user that last modified this record

  - `sys_last_security_context` (object)
    The security context of the last insert, modify, or delete performed on this item

  - `sys_locked` (boolean)
    If set, this record is locked and cannot be changed via the API

  - `sys_snapshot_base_version` (number)
    The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

  - `sys_version` (number)
    A number representing the version of this record in the database

## Response 200 headers (application/json):

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 400:

  - `400` (unknown)
    The custom object you supplied was invalid.

## Response 400 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 401:

  - `401` (unknown)
    Unauthorized.

## Response 401 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 403:

  - `403` (unknown)
    Forbidden.

## Response 403 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 404:

  - `404` (unknown)
    The resource could not be found

## Response 404 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 409:

  - `409` (unknown)
    The custom object could not be saved because it refers to/depends on a non-existent object.

## Response 409 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 429:

  - `429` (unknown)
    Limit exceeded... unable to add custom object based on tenant limits.

## Response 429 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

## Response 500:

  - `500` (unknown)
    General server error.

## Response 500 headers:

  - `Access-Control-Allow-Headers` (string)

  - `Access-Control-Allow-Methods` (string)

  - `Access-Control-Allow-Origin` (string)

